//
// choose_dict.js
//
const Cc = Components.classes;
const Ci = Components.interfaces;

const miduuidlen = 37;
const midNS      = "http://mid.mozdev.org/dictionaries";

var gPrefs = Components.classes["@mozilla.org/preferences-service;1"].
    getService(Components.interfaces.nsIPrefBranch);

var gLines       = [];
var gDictionary	  = "default"
var gAllDictArray = [];

function dc__initAll() {

    var i, j, iDict = {}, iType, type, mAllTypes, mType;
    var mTabPanels, mTabs, mTabPanel, mNewTab, mNewTabPanel, mNewCheck;
    var mNewDictionary = [], mFirstTab = "", mTypesArray = [];
 
    if (!window.arguments) { 
        var button = document.documentElement.getButton;
        button('extra1').collapsed = true; button('extra2').collapsed = true;
        button('disclosure').collapsed = true;
    } else {
        var d = window.arguments[0].dictionary;
        if (!d || d == "" || d == "temporary" || d == "new"  || d == "default") { 
        	document.documentElement.getButton('extra2').collapsed = true;
        }
        if (d) gDictionary = d; 
    }

    mAllTypes = " ";
    var allDictsXML = document.getElementsByTagNameNS(midNS, "dict");

    for (i = 0; (iDict = allDictsXML.item(i)); i++) {
        type = iDict.getAttribute("type");
        var marker = "";
        if (iDict.getAttribute("special") == "yes") {
            marker = "+";
        }
        type = marker + type; 
        if (typeof(gAllDictArray[type]) == "undefined") {
	        gAllDictArray[type] = [];
        }

        mNewDictionary = new dc__dictionaryObj(
                iDict.getAttribute("dictid"), type, iDict.getAttribute("checked"),
                iDict.getAttribute("restrictions") ? iDict.getAttribute("restrictions") : ""  , 0);

        gAllDictArray[type][iDict.getAttribute("label")]  = mNewDictionary;

        if (mAllTypes.indexOf(type) == -1) {
            mAllTypes = mAllTypes + type + " ";
            mTypesArray.push(type);
       }
    }
    
    mTypesArray.sort(
        function(a, b) {
            if ((b.charAt(0) == "+")  && (a.charAt(0) == "+")) { 
                return a.toLocaleLowerCase().localeCompare(b.toLocaleLowerCase());
            }
            if (b.charAt(0) == "+") {
                return -1;
            }
            if (a.charAt(0) == "+") {
                return  1;
            }
            return a.toLocaleLowerCase().localeCompare(b.toLocaleLowerCase()); 
        }
    );

    mTabs = document.getElementById("mid_dicttypetabs"); 
    mTabPanels = document.getElementById("mid_dicttypetabpanels"); 

    for (i = 0; i < mTypesArray.length; i++) {
        mType = mTypesArray[i];
        var first  = mType.charAt(0).toUpperCase();
        var tabid = "mid_choosdicttab" + first;
        var tabIsNew = false;
        if (!document.getElementById(tabid)) {
            tabIsNew = true;
            mNewTab = document.createElement("tab");
            mNewTab.setAttribute("label", " " + first + " ");
            mNewTab.setAttribute("id", tabid);
            mNewTabPanel = document.createElement("listbox");
            mNewTabPanel.setAttribute("rows", "14");
            mNewTabPanel.setAttribute("id", "mid_choosedictpanel" + first);
            // mNewTabPanel.setAttribute("onkeydown", "dc__typeCheckBoxChangeKey(event);");
            mTabs.appendChild(mNewTab);
            mTabPanels.appendChild(mNewTabPanel);
            mTabPanel = mNewTabPanel; 
        } else {
            mTabPanel = document.getElementById("mid_choosedictpanel" + first);
        }
        
        mNewCheck = document.createElement("listitem");
        mNewCheck.setAttribute("type", "checkbox");
        mNewCheck.setAttribute("id", "mid_choosedictcheck" + i);
        mNewCheck.setAttribute("label", mType.replace(/^\+/,""));
        mNewCheck.setAttribute("value", mType);
        mNewCheck.setAttribute("crop", "none");
        // 9.16 mNewCheck.setAttribute("onmousedown", "dc__typeCheckBoxChange(event);");
        mTabPanel.appendChild(mNewCheck);
        mNewCheck.setAttribute("checked", "false");

        if (window.arguments)  {
            // called from mid
            if (dt__checkThisType(mType)) {
                mNewCheck.setAttribute("checked", "true");
            }
        }
        else {
            // from preferences not very much used
            if (gPrefs.getPrefType("extensions.mid.dtype." + mType) == gPrefs.PREF_BOOL) {
                mNewCheck.setAttribute("checked", gPrefs.getBoolPref("extensions.mid.dtype." + mType.replace(/^\+/,"")));
            } else {
                for (j = 0; (iType = document.getElementsByTagNameNS(midNS, "default-dict-type").item(j)); j++) {
                    if (iType.getAttribute("label") == mType.replace(/^\+/,"")) {
                        mNewCheck.setAttribute("checked", "true");
                    }
                } // XML
            }
        }

        if (mNewCheck.getAttribute("checked") == "true") {
            document.getElementById(tabid).setAttribute("vanchecked","true");
	        dt__getDictionaries(mType, "init");
            if (mFirstTab == "") { 
                mFirstTab = tabid;
            }
        }

    }  // for

    if (mFirstTab != "") {
        var mListBox = document.getElementById("mid_selectdictionaries");
        mListBox.scrollToIndex(0);
        mListBox.selectItem(mListBox.getItemAtIndex(1));
        var t = document.getElementById(mFirstTab);
        mTabs.selectedItem = t;

        var list  = mTabPanels.selectedPanel;
	var lItem = list.firstChild;
        while (lItem) {
            if ( lItem.getAttribute("checked") == "true" ) break;
            lItem = lItem.nextSibling;
        }
	// alert("OK");
        if (lItem) { 
		list.ensureElementIsVisible(lItem);
                list.timedSelect(lItem, 100);
        }
    }
    else { 
        mTabs.selectedIndex = 0;
    }
   
} // function initAll 


function dc__dictionaryObj(aDictId, aDictType, aDictChecked, aDictRestrictions, aDictIcon, aDictWeigth)
{
    this.mDictId           = aDictId;
    this.mDictType         = aDictType;
    this.mDictChecked      = aDictChecked;
    this.mDictRestrictions = aDictRestrictions;
    this.mDictIcon         = aDictIcon;
    this.mDictWeigth       = aDictWeigth;
}

 
function dc__saveChanges()
{ 
    var i, dt;

    if (window.arguments) {
        window.arguments[0].result = true;
        gDictionary = window.arguments[0].dictionary; 
    }

    for (i = 0; (dt = document.getElementById("mid_dicttypetabbox").getElementsByTagName("listitem").item(i)); i++) {
        if (dt.getAttribute("checked") == "true") {
            if (gDictionary == "default") {
                gPrefs.setBoolPref("extensions.mid.dtype." + dt.getAttribute("label"), true);
            }
            dt__savePreferences(dt.getAttribute("value"));
        } 
    }

    window.arguments[0].mylines = gLines;
    window.arguments[0].result = false;
}



function dc__typeCheckBoxChangeKey(aEvent)             
{
    if (!aEvent) return;
    var e = aEvent;

    var key = e.which;
    if (key == 32) {
        dc__typeCheckBoxChange(e);
    }
    return true;
}



function dc__typeCheckBoxChange(aEvent)             
{
    
    var li = aEvent.originalTarget;

    var i, dt, isChecked, label;
    var typeTab   = document.getElementById("mid_dicttypetabbox").selectedTab;
    var typePanel = document.getElementById("mid_dicttypetabbox").selectedPanel;

    if (li.nodeName != "listitem") {
	    return;
    }

    isChecked = false;
    label = li.getAttribute("label");
    if (li.getAttribute("checked") == "true") {    
        dt__getDictionaries(li.getAttribute("value"), "click");
        isChecked = true; }
    else {
        dt__removeDictionariesFromList(li.getAttribute("label"));
        for (i = 0; (dt = typePanel.getElementsByTagName("listitem").item(i));i++) {
            if (!(dt.getAttribute("label") == li.getAttribute("label"))) { 
                if (dt.getAttribute("checked") == "true") {
                    isChecked = true;
                }
            }
        }
    }
    typeTab.setAttribute("vanchecked", isChecked);
}



function dt__getDictionaries(aType, aCallerType)
{

    var mType = aType;
    var mCallerType = aCallerType;
    var mListItem, mDictRestrictions, mDict, d, mDictId;
    var realtype =  mType.replace(/^\+/, ""); 
    var mListBox = document.getElementById("mid_selectdictionaries");
    // 9.16 mListBox.setAttribute("onkeypress", "dt__onKeypressDictionaryList(this, event);");

    var mListItemH =  document.createElement('listitem');
    var mListHeader    = document.createElement('listcell');
    mListHeader.setAttribute("label", realtype + " : ");
    mListHeader.setAttribute("value", realtype);
    var mPlaceHolder = document.createElement('listcell');
    mListItemH.appendChild(mListHeader);
    mListItemH.appendChild(mPlaceHolder);
    mListItemH.setAttribute("disabled", true);
    mListItemH.setAttribute("value", realtype);
    mListBox.appendChild(mListItemH);

    for (d in gAllDictArray[mType]) {
        mListItem =  document.createElement('listitem');
        mDictRestrictions = document.createElement('listcell');
        mDict = document.createElement('listcell');
        mDictRestrictions.setAttribute('label', gAllDictArray[mType][d].mDictRestrictions);
        mDictRestrictions.setAttribute("crop", "none"); 
        mDict.setAttribute('label', d);
        mDict.setAttribute('value', mType);
           
        mListItem.setAttribute('value', realtype);
        // mListItem.setAttribute("type", 'checkbox');
        mDict.setAttribute("id", "mid_" + d);
        mDict.setAttribute("type", "checkbox");
        // 9.16 mDict.setAttribute("Onclick", "dt__onselectDictionary(this);");

        // 9.14.7 mDict.setAttribute("style", "white-space : nowrap !important; min-width:14em;");
        
	   // defaults from XUL. 
        if (gAllDictArray[mType][d].mDictChecked  == "true") {
            mDict.setAttribute("checked", "true");
        } else {
            mDict.setAttribute("checked", "false");
        }

        mDictId = gAllDictArray[mType][d].mDictId;

        if (gPrefs.getPrefType("extensions.mid." + mDictId + "_checked") == gPrefs.PREF_BOOL) {
            if (gPrefs.getBoolPref("extensions.mid." + mDictId + "_checked") == true) {
                gAllDictArray[mType][d].mDictChecked = "true";
                mDict.setAttribute("checked", "true");
            } else {
                mDict.setAttribute("checked", "false");
                gAllDictArray[mType][d].mDictChecked = "false";
            }
        }  // pref exists?
       
        // from facts
        if (window.opener && dt__checkThisType(mType)) {
            mDict.setAttribute("checked", "false");
            gAllDictArray[mType][d].mDictChecked = "false";
            if (window.opener.document.getElementById('tab' + mDictId)) {
                gAllDictArray[mType][d].mDictChecked = "false";
                if (!(window.opener.document.getElementById('tab' + mDictId).getAttribute("collapsed") == "true")) {
                    gAllDictArray[mType][d].mDictChecked = "true";
                    mDict.setAttribute("checked", "true");
                }
            }
        }
        mListItem.appendChild(mDict);
        mListItem.appendChild(mDictRestrictions);
        mListBox.appendChild(mListItem);
        mListItem.setAttribute("allowevents", "true");
    } // for


    if (mCallerType != "init") {
        var x = mListBox.getIndexOfItem(mListItemH);
        mListBox.ensureIndexIsVisible(x + 1);
        mListBox.selectItem(mListBox.getItemAtIndex(x + 1));
    }
}



function dt__checkThisType(aType) 
{
    var ctab, retvalue = false;
    var t = aType;    
    for (var d in gAllDictArray[t]) {
        ctab = window.opener.document.getElementById('tab' + gAllDictArray[t][d].mDictId);  
        if (ctab) {
            if (ctab.getAttribute("collapsed") != "true") {
                retvalue = true;
            }
        }
    }
    return retvalue;
}



function dt__removeDictionariesFromList(aType)
{
    var mType = aType;
    var i, li;
    var mListBox = document.getElementById("mid_selectdictionaries");

    mListBox.clearSelection();
    var c = mListBox.getRowCount();
    mListBox.scrollToIndex(0);
    // mListBox.ensureIndexIsVisible(0); //?

    for (i = c - 1; (i > - 1); i--) {
        li = mListBox.getItemAtIndex(i);
        if ((li.getAttribute("value") == mType) || (li.getAttribute("value") == "+" + mType)) {
            while (li.hasChildNodes()) {
                li.removeChild(li.lastChild);
            }
   	        mListBox.removeItemAt(mListBox.getIndexOfItem(li));
	        li = null;
        }
    }
}




function dt__onselectDictionary(aEventTarget)
{
    var el              = aEventTarget; 
    if  (!el.hasAttribute("checked")) return;

    var d = el.getAttribute("label");
    var t = el.getAttribute("value");
    var checked = el.getAttribute("checked");
         
    if (checked == "true") {
        gAllDictArray[t][d].mDictChecked = "false";
        el.setAttribute("checked", "false"); 
    }
    else { 
        gAllDictArray[t][d].mDictChecked = "true";
        el.setAttribute("checked", "true");
    }
}



function dt__savePreferences(aType) 
{
    var t = aType;
    var mDictId, d, mDictChecked = false;

    for (d in gAllDictArray[t]) {
        mDictId = gAllDictArray[t][d].mDictId; 
        if (gAllDictArray[t][d].mDictChecked == "true") {
            gLines.push(mDictId);
            mDictChecked = true;
        }
        else {
            mDictChecked = false;
            if (gLines.join().indexOf(mDictId) > -1) {
                gLines.splice((gLines.join().indexOf(mDictId) / 37), 1); 
            }
        }
        if (gDictionary == "default") {
            gPrefs.setBoolPref("extensions.mid." + mDictId + "_checked", mDictChecked);
        }
    }
    // alert(gLines);
    
    return true;
}



function dt__onKeypressDictionaryList(aEvent)
{ 
    if (!aEvent) return;
    
    var e = aEvent;
    var lb = e.target;
    var key = e.which;
	
    if (key == 32) {
        dt__onselectDictionary(lb.selectedItem.getElementsByTagName("listcell").item(0));
    } 
    return true;
}

function dt__onClickDictionaryList(list) {

    if (!list) return;
    dt__onselectDictionary(list.selectedItem.getElementsByTagName("listcell").item(0));
    return true;
}

function dt__firstSelTabFocus()
{
    var mTabs = document.getElementById("mid_dicttypetabs"); 
    mTabs.selectedItem.focus();
}



function dt__onTypeCheckFocus(tc)
{
    var xpcomInterface = tc.parentNode.boxObject.QueryInterface(
                         Components.interfaces.nsIScrollBoxObject);
    xpcomInterface.ensureElementIsVisible(tc);
}

function dc__tabSelect(tabs){
	var t = tabs.selectedItem;
	if (!t.getAttribute("vanchecked","true"))
            return;
   	var list  = document.getElementById("mid_dicttypetabpanels").selectedPanel;
        var lItem = list.firstChild;
        while (lItem) {
            if ( lItem.getAttribute("checked") == "true" ) break;
            lItem = lItem.nextSibling;
        }
        if (lItem) {
           list.ensureElementIsVisible(lItem);
           list.timedSelect(lItem, 100);
        }
}

function dumpToConsole(aMessage) {
	var consoleService = Cc["@mozilla.org/consoleservice;1"].getService(Ci.nsIConsoleService);
	consoleService.logStringMessage("mid_ " + aMessage);
}
 

